
#include "main.h"
#include "SSD1289.h"

#define     __IO    volatile
#define CODEC_MCLK_ENABLED
#define AUDIO_INTERFACE_DAC           1
#define AUDIO_INTERFACE_I2S           1
#define AUDIO_DAC_CHANNEL             DAC_Channel_1

#define I2S_STANDARD                 I2S_Standard_Phillips



/* The 7 bits Codec address (sent through I2C interface) */
#define CS43L22_ADDRESS         0x94// RTC CS43L22C2

#define USE_DEFAULT_TIMEOUT_CALLBACK
NVIC_InitTypeDef  NVIC_InitStructure;

#define CS43L22_I2C                     I2C1
#define CS43L22_I2C_CLK                 RCC_APB1Periph_I2C1
#define CS43L22_I2C_GPIO_CLOCK          RCC_AHB1Periph_GPIOB

#define CS43L22_I2C_GPIO_AF             GPIO_AF_I2C1
#define CS43L22_I2C_GPIO               	GPIOB
#define CS43L22_I2C_SCL_PIN             GPIO_Pin_6
#define CS43L22_I2C_SDA_PIN             GPIO_Pin_9
#define CS43L22_I2S_SCL_PINSRC          GPIO_PinSource6
#define CS43L22_I2S_SDA_PINSRC          GPIO_PinSource9

#define AUDIO_RESET_GPIO_CLK           	RCC_AHB1Periph_GPIOD
#define AUDIO_RESET_PIN                	GPIO_Pin_4
#define AUDIO_RESET_GPIO               	GPIOD

/* I2S peripheral configuration defines */
#define CODEC_I2S                      	SPI3
#define CODEC_I2S_CLK                  	RCC_APB1Periph_SPI3
#define CODEC_I2S_ADDRESS              	0x40003C0C
#define CODEC_I2S_GPIO_AF             	GPIO_AF_SPI3
#define CODEC_I2S_IRQ                  	SPI3_IRQn
#define CODEC_I2S_GPIO_CLOCK           	(RCC_AHB1Periph_GPIOC | RCC_AHB1Periph_GPIOA)
#define CODEC_I2S_WS_PIN               	GPIO_Pin_4
#define CODEC_I2S_SCK_PIN              	GPIO_Pin_10
#define CODEC_I2S_SD_PIN               	GPIO_Pin_12
#define CODEC_I2S_MCK_PIN              	GPIO_Pin_7
#define CODEC_I2S_WS_PINSRC            	GPIO_PinSource4
#define CODEC_I2S_SCK_PINSRC           	GPIO_PinSource10
#define CODEC_I2S_SD_PINSRC            	GPIO_PinSource12
#define CODEC_I2S_MCK_PINSRC           	GPIO_PinSource7
#define CODEC_I2S_GPIO                	GPIOC
#define CODEC_I2S_WS_GPIO              	GPIOA
#define CODEC_I2S_MCK_GPIO             	GPIOC
#define Audio_I2S_IRQHandler           	SPI3_IRQHandler


#define I2S_INTERRUPT

#ifndef I2C_SPEED
#define I2C_SPEED                        100000
#endif /* I2C_SPEED */
/* Codec audio Standards */
#define I2S_STANDARD                   I2S_Standard_Phillips

//#define CS43L22_MCLK_ENABLED
//#define VERIFY_WRITTENDATA

TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure;
TIM_OCInitTypeDef  TIM_OCInitStructure;
TIM_BDTRInitTypeDef TIM_BDTRInitStructure;



#define CS43L22_FLAG_TIMEOUT             ((uint32_t)0x1000)
#define CS43L22_LONG_TIMEOUT             ((uint32_t)(300 * CS43L22_FLAG_TIMEOUT))

__IO uint32_t  CODECTimeout = CS43L22_LONG_TIMEOUT;

__IO uint32_t CurrAudioInterface = AUDIO_INTERFACE_I2S; //AUDIO_INTERFACE_DAC


uint8_t ret;

uint8_t test[]="STM32F4-Discovery";
uint8_t test1[]="CS43L22";
uint8_t test3[]="Ende";

//uint16_t test2[]= ;
Point * Points;

int main(void)
{

	SystemInit();
	systickInit(1000); //1000 ticks per second for delay_ms(xx)
	SSD1289_Hardware_init();
	LCD_Init();
	//LCD_CharSize(24);

	LCD_Clear(GREEN);
	LCD_SetBackColor(GREEN);
	LCD_SetTextColor(BLACK);
	LCD_StringLine(10,10,test);
	//LCD_DrawFullRect(0, 140, 240, 100);//LCD_DrawUniLine(0, 240, 100, 280);

	init_tim2(); 		// Timer2 Imterrupt auf 0,5 Sekunden

//	LCD_PolyLine( pPoint Points ,100);
//	LCD_PolyLine(pPoint Points->X, Points.->10, 100);
	/* Initialize LEDs */


	CS43L22_Config();
	CS43L22_GPIO_Init();
	CS43L22_Reset();
	//Codec_AudioInterface_Init(2000);

	STM_EVAL_LEDInit(LED5);
	STM_EVAL_LEDInit(LED3);

	CS43L22_schreiben();	//Datum und Zeit einstellen STM32F4 RTC
	CS43L22_lesen();
	STM_EVAL_LEDOn(LED3);		// wenn LED6 leuchtet alles Init ok!!

	//POLY_X(0x10);

  /* Infinite loop */
  while (1)
  {
	  delay_ms(250);

	  LCD_CharSize(24);
	  LCD_StringLine(10,95,test1);

	  LCD_CharSize(16);
	  delay_ms(250);

  }
}

void CS43L22_Config(void)
{
	GPIO_InitTypeDef  GPIO_InitStructure;

	 /* GPIO Periph clock enable */
	RCC_AHB1PeriphClockCmd(CS43L22_I2C_GPIO_CLOCK, ENABLE);

	 /* CS43L22_I2C SCL pins configuration -------------------------------------*/
	GPIO_InitStructure.GPIO_Pin = CS43L22_I2C_SCL_PIN | CS43L22_I2C_SDA_PIN;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_OType = GPIO_OType_OD;
	GPIO_InitStructure.GPIO_PuPd  = GPIO_PuPd_NOPULL;
	GPIO_Init(GPIOB, &GPIO_InitStructure);


	/* Connect pins to I2C peripheral */
	GPIO_PinAFConfig(GPIOB, CS43L22_I2S_SCL_PINSRC, CS43L22_I2C_GPIO_AF);
	GPIO_PinAFConfig(GPIOB, CS43L22_I2S_SDA_PINSRC, CS43L22_I2C_GPIO_AF);

	I2C_InitTypeDef I2C_InitStructure;

	/* Enable the CODEC_I2C peripheral clock */
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_I2C1, ENABLE);

	/* CODEC_I2C peripheral configuration */
	I2C_DeInit(I2C1);
	I2C_InitStructure.I2C_Mode = I2C_Mode_I2C;
	I2C_InitStructure.I2C_DutyCycle = I2C_DutyCycle_2;
	I2C_InitStructure.I2C_OwnAddress1 = 0x33;
	I2C_InitStructure.I2C_Ack = I2C_Ack_Enable;
	I2C_InitStructure.I2C_AcknowledgedAddress = I2C_AcknowledgedAddress_7bit;
	I2C_InitStructure.I2C_ClockSpeed = I2C_SPEED;
	/* Enable the I2C peripheral */
	I2C_Cmd(I2C1, ENABLE);
	I2C_Init(I2C1, &I2C_InitStructure);
}

  void CS43L22_GPIO_Init(void)
 {
   GPIO_InitTypeDef GPIO_InitStructure;

   /* Enable Reset GPIO Clock */
   RCC_AHB1PeriphClockCmd(AUDIO_RESET_GPIO_CLK,ENABLE);

   /* Audio reset pin configuration -------------------------------------------------*/
   GPIO_InitStructure.GPIO_Pin = AUDIO_RESET_PIN;
   GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
   GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
   GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
   GPIO_InitStructure.GPIO_PuPd  = GPIO_PuPd_NOPULL;
   GPIO_Init(AUDIO_RESET_GPIO, &GPIO_InitStructure);

   /* CODEC_I2S pins configuration: WS, SCK and SD pins -----------------------------*/
   GPIO_InitStructure.GPIO_Pin = CODEC_I2S_SCK_PIN | CODEC_I2S_SD_PIN;
   GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
   GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
   GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
   GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
   GPIO_Init(CODEC_I2S_GPIO, &GPIO_InitStructure);

   /* Connect pins to I2S peripheral  */
   GPIO_PinAFConfig(CODEC_I2S_WS_GPIO, CODEC_I2S_WS_PINSRC, CODEC_I2S_GPIO_AF);
   GPIO_PinAFConfig(CODEC_I2S_GPIO, CODEC_I2S_SCK_PINSRC, CODEC_I2S_GPIO_AF);

   GPIO_InitStructure.GPIO_Pin = CODEC_I2S_WS_PIN ;
   GPIO_Init(CODEC_I2S_WS_GPIO, &GPIO_InitStructure);
   GPIO_PinAFConfig(CODEC_I2S_GPIO, CODEC_I2S_SD_PINSRC, CODEC_I2S_GPIO_AF);

  #ifdef CODEC_MCLK_ENABLED
    /* CODEC_I2S pins configuration: MCK pin */
    GPIO_InitStructure.GPIO_Pin = CODEC_I2S_MCK_PIN;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
    GPIO_Init(CODEC_I2S_MCK_GPIO, &GPIO_InitStructure);
    /* Connect pins to I2S peripheral  */
    GPIO_PinAFConfig(CODEC_I2S_MCK_GPIO, CODEC_I2S_MCK_PINSRC, CODEC_I2S_GPIO_AF);
  #endif /* CODEC_MCLK_ENABLED */
  }

  void Codec_AudioInterface_Init(uint32_t AudioFreq)
  {
    I2S_InitTypeDef I2S_InitStructure;
    /* Enable the CODEC_I2S peripheral clock */
    RCC_APB1PeriphClockCmd(CODEC_I2S_CLK, ENABLE);

    /* CODEC_I2S peripheral configuration */
    SPI_I2S_DeInit(CODEC_I2S);
    I2S_InitStructure.I2S_AudioFreq = AudioFreq;
    I2S_InitStructure.I2S_Standard = I2S_Standard_Phillips;
    I2S_InitStructure.I2S_DataFormat = I2S_DataFormat_16b;
    I2S_InitStructure.I2S_CPOL = I2S_CPOL_Low;
    I2S_InitStructure.I2S_Mode = I2S_Mode_MasterTx;
    I2S_InitStructure.I2S_MCLKOutput = I2S_MCLKOutput_Enable;
    I2S_Init(CODEC_I2S, &I2S_InitStructure);
  }


  void CS43L22_Reset(void)
  {
    /* Power Down the codec */
    GPIO_WriteBit(AUDIO_RESET_GPIO, AUDIO_RESET_PIN, Bit_RESET);

    /* wait for a delay to insure registers erasing */
    delay_ms(50); //Delay(CODEC_RESET_DELAY);

    /* Power on the codec */
    GPIO_WriteBit(AUDIO_RESET_GPIO, AUDIO_RESET_PIN, Bit_SET);
  }



uint8_t CS43L22_WriteRegister(uint8_t RegisterAddr, uint8_t RegisterValue)
{
  uint32_t result = 0;

  /*!< While the bus is busy */
  CODECTimeout = CS43L22_LONG_TIMEOUT;
  while(I2C_GetFlagStatus(CS43L22_I2C, I2C_FLAG_BUSY))
  {
    if((CODECTimeout--) == 0) return CS43L22_TIMEOUT_UserCallback();
  }

  /* Start the config sequence */
  I2C_GenerateSTART(CS43L22_I2C, ENABLE);

  /* Test on EV5 and clear it */
  CODECTimeout = CS43L22_FLAG_TIMEOUT;
  while (!I2C_CheckEvent(CS43L22_I2C, I2C_EVENT_MASTER_MODE_SELECT))
  {
    if((CODECTimeout--) == 0) return CS43L22_TIMEOUT_UserCallback();
  }

  /* Transmit the slave address and enable writing operation */
  I2C_Send7bitAddress(CS43L22_I2C, CS43L22_ADDRESS, I2C_Direction_Transmitter);

  /* Test on EV6 and clear it */
  CODECTimeout = CS43L22_FLAG_TIMEOUT;
  while (!I2C_CheckEvent(CS43L22_I2C, I2C_EVENT_MASTER_TRANSMITTER_MODE_SELECTED))
  {
    if((CODECTimeout--) == 0) return CS43L22_TIMEOUT_UserCallback();
  }

  /* Transmit the first address for write operation */
  I2C_SendData(CS43L22_I2C, RegisterAddr);

  /* Test on EV8 and clear it */
  CODECTimeout = CS43L22_FLAG_TIMEOUT;
  while (!I2C_CheckEvent(CS43L22_I2C, I2C_EVENT_MASTER_BYTE_TRANSMITTING))
  {
    if((CODECTimeout--) == 0) return CS43L22_TIMEOUT_UserCallback();
  }

  /* Prepare the register value to be sent */
  I2C_SendData(CS43L22_I2C, RegisterValue);

  /*!< Wait till all data have been physically transferred on the bus */
  CODECTimeout = CS43L22_LONG_TIMEOUT;
  while(!I2C_GetFlagStatus(CS43L22_I2C, I2C_FLAG_BTF))
  {
    if((CODECTimeout--) == 0) CS43L22_TIMEOUT_UserCallback();
  }

  /* End the configuration sequence */
  I2C_GenerateSTOP(CS43L22_I2C, ENABLE);

  /* Return the verifying value: 0 (Passed) or 1 (Failed) */
  return result;
}

/**
  * @brief  Reads and returns the value of an audio codec register through the
  *         control interface (I2C).
  * @param  RegisterAddr: Address of the register to be read.
  * @retval Value of the register to be read or dummy value if the communication
  *         fails.
  */
uint8_t CS43L22_ReadRegister(uint8_t RegisterAddr)
{
  uint32_t result = 0;

  /*!< While the bus is busy */
  CODECTimeout = CS43L22_LONG_TIMEOUT;
  while(I2C_GetFlagStatus(CS43L22_I2C, I2C_FLAG_BUSY))
  {

	  if((CODECTimeout--) == 0) return CS43L22_TIMEOUT_UserCallback();
  }

  /* Start the config sequence */
  I2C_GenerateSTART(CS43L22_I2C, ENABLE);

  /* Test on EV5 and clear it */
  CODECTimeout = CS43L22_FLAG_TIMEOUT;
  while (!I2C_CheckEvent(CS43L22_I2C, I2C_EVENT_MASTER_MODE_SELECT))
  {



	  if((CODECTimeout--) == 0) return CS43L22_TIMEOUT_UserCallback();
  }

  /* Transmit the slave address and enable writing operation */
  I2C_Send7bitAddress(CS43L22_I2C, CS43L22_ADDRESS, I2C_Direction_Transmitter);

  /* Test on EV6 and clear it */
  CODECTimeout = CS43L22_FLAG_TIMEOUT;
  while (!I2C_CheckEvent(CS43L22_I2C, I2C_EVENT_MASTER_TRANSMITTER_MODE_SELECTED))
  {

	  if((CODECTimeout--) == 0) return CS43L22_TIMEOUT_UserCallback();
  }

  /* Transmit the register address to be read */
  I2C_SendData(CS43L22_I2C, RegisterAddr);

  /* Test on EV8 and clear it */
  CODECTimeout = CS43L22_FLAG_TIMEOUT;
  while (I2C_GetFlagStatus(CS43L22_I2C, I2C_FLAG_BTF) == RESET)
  {
    if((CODECTimeout--) == 0) return CS43L22_TIMEOUT_UserCallback();
  }

  /*!< Send START condition a second time */
  I2C_GenerateSTART(CS43L22_I2C, ENABLE);

  /*!< Test on EV5 and clear it (cleared by reading SR1 then writing to DR) */
  CODECTimeout = CS43L22_FLAG_TIMEOUT;
  while(!I2C_CheckEvent(CS43L22_I2C, I2C_EVENT_MASTER_MODE_SELECT))
  {
    if((CODECTimeout--) == 0) return CS43L22_TIMEOUT_UserCallback();
  }

  /*!< Send Codec address for read */
  I2C_Send7bitAddress(CS43L22_I2C, CS43L22_ADDRESS, I2C_Direction_Receiver);
   /* Wait on ADDR flag to be set (ADDR is still not cleared at this level */
  CODECTimeout = CS43L22_FLAG_TIMEOUT;
  while(I2C_GetFlagStatus(CS43L22_I2C, I2C_FLAG_ADDR) == RESET)
  {
    if((CODECTimeout--) == 0) return CS43L22_TIMEOUT_UserCallback();
  }

  /*!< Disable Acknowledgment */
  I2C_AcknowledgeConfig(CS43L22_I2C, DISABLE);

  /* Clear ADDR register by reading SR1 then SR2 register (SR1 has already been read) */
  (void)CS43L22_I2C->SR2;

  /*!< Send STOP Condition */
  I2C_GenerateSTOP(CS43L22_I2C, ENABLE);

  /* Wait for the byte to be received */
  CODECTimeout = CS43L22_FLAG_TIMEOUT;
  while(I2C_GetFlagStatus(CS43L22_I2C, I2C_FLAG_RXNE) == RESET)
  {
    if((CODECTimeout--) == 0) return CS43L22_TIMEOUT_UserCallback();
  }

  /*!< Read the byte received from the Codec */
  result = I2C_ReceiveData(CS43L22_I2C);

  /* Wait to make sure that STOP flag has been cleared */
  CODECTimeout = CS43L22_FLAG_TIMEOUT;
  while(CS43L22_I2C->CR1 & I2C_CR1_STOP)
  {
    if((CODECTimeout--) == 0) return CS43L22_TIMEOUT_UserCallback();
  }

  /*!< Re-Enable Acknowledgment to be ready for another reception */
  I2C_AcknowledgeConfig(CS43L22_I2C, ENABLE);

  /* Clear AF flag for next communication */
  I2C_ClearFlag(CS43L22_I2C, I2C_FLAG_AF);

  /* Return the byte read from Codec */


  return result;
}


void CS43L22_lesen(void)
{
uint8_t daten;
	//  TWI-Daten nach struct rtc
char  result[]="                                ";


daten = CS43L22_ReadRegister(0x01); 	//sek

sprintf(result, "Ausgabe %x",( char)daten);

LCD_StringLine(110,140,(unsigned char*)result);

}

void CS43L22_schreiben(void)
{

	CS43L22_WriteRegister(0x27, 0x00);



	  CS43L22_WriteRegister(0x1C, 0x80);


		CS43L22_WriteRegister(0x1E, 0x00);


	  	CS43L22_WriteRegister(0x1E, 0x40);



	/*

			CS43L22_WriteRegister(0x50,0x34);
			CS43L22_WriteRegister(0x02,0x9E);
			CS43L22_WriteRegister(0x04,0xBF);
			CS43L22_WriteRegister(0x0F,0xC0);
			CS43L22_WriteRegister(0x14,0x00);
			CS43L22_WriteRegister(0x15,0x00);


			CS43L22_WriteRegister(0x00,0x22);
			CS43L22_WriteRegister(0x00,0x23);

			CS43L22_WriteRegister(0x18,0x20);
			CS43L22_WriteRegister(0x18,0x21);
			CS43L22_WriteRegister(0x80,0x1A);
			CS43L22_WriteRegister(0x80,0x1B);
			CS43L22_WriteRegister(0x78,0x1C);
			CS43L22_WriteRegister(0x00,0x1D);
		 	CS43L22_WriteRegister(0xC3,0x1E);  */


}

void init_tim2(void)
{
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2, ENABLE);    //TIM2 mit einem Takt versorgen

	NVIC_InitStructure.NVIC_IRQChannel = TIM2_IRQn;   //Interrupt Kanal auswhlen. Hier TIM2
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1; //Interrupt Prioritt festlegen
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;      //Interrupt Unterprioritt festlegen
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;         //Aktivieren des Interrupts
	NVIC_Init(&NVIC_InitStructure);                         //Konfiguration bernehmen



	TIM_TimeBaseStructure.TIM_Prescaler = 5250;                 // Clock Teiler 168MHz / 5250 = 32kHz
	TIM_TimeBaseStructure.TIM_Period = 16000;                   // Anzahl Durchlufe bis berlauf Interrupt 32kHz / 16000 = 0,5s
	TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1;     //Keine Clock Division
	TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up; //Hochzhlender Timer Modus
	TIM_TimeBaseInit(TIM2,&TIM_TimeBaseStructure);
	TIM_Cmd(TIM2, ENABLE);                                  //Timer Aktivieren

	TIM_ClearFlag(TIM2,TIM_FLAG_Update);                   //Interrupt Flag von TIM2 lschen
	TIM_ITConfig(TIM2,TIM_IT_Update, ENABLE);              //Interrupt fr TIM2 Aktivieren
	TIM_ClearFlag(TIM2,TIM_FLAG_Update);                   //Interrupt Flag fr TIM2 Lschen

}



void TIM2_IRQHandler(void)
{
	TIM_ClearFlag(TIM2, TIM_FLAG_Update);         //Interrupt Flag von TIM2 Lschen
	//STM_EVAL_LEDToggle(LED5);

	//Interrupt Flag von TIM2 Lschen
}

#ifdef USE_DEFAULT_TIMEOUT_CALLBACK
/**
  * @brief  Basic management of the timeout situation.
  * @param  None
  * @retval None
  */
uint32_t CS43L22_TIMEOUT_UserCallback(void)
{
  /* Block communication and all processes */
  while (1)
  {
	  STM_EVAL_LEDToggle(LED5);
  }
}
#endif /* USE_DEFAULT_TIMEOUT_CALLBACK */

// Ende

