#include "stm32f4xx.h"
#include "systick.h"



static volatile uint32_t ticks;
static RCC_ClocksTypeDef RCC_Clocks;

void systickInit(uint16_t frequency) {
  RCC_GetClocksFreq(&RCC_Clocks);
  SysTick_Config(RCC_Clocks.HCLK_Frequency / frequency);
}


// TODO: nasty constant for timing. This value correct for STM32F4 at 72MHz
#define COUNTS_PER_MICROSECOND 22

inline void delay_us(uint32_t microseconds) {
  uint32_t count = microseconds * COUNTS_PER_MICROSECOND - 2;
  __asm volatile("   mov r0, %[count]          \n\t"
          "1: subs r0, #1            \n\t"
          "   bhi 1b                 \n\t"
          :
          : [count] "r" (count)
          : "r0");
}

void delay_ms(uint32_t t) {
  //t += ticks;
  uint32_t start, end;
  //uint16_t waiting;
  start = ticks;
  end = start + t;
  if (start < end) {
    while ((ticks >= start) && (ticks < end)) {
      // wait
    }
  } else {
    while ((ticks >= start) || (ticks < end)) {
      // wait
    };
  }
  SysTick->VAL;
}

uint32_t getSystemTicks(void) {
  return ticks;
}

void SysTick_Handler(void) {

  ticks++;


}
